import{S as Oi,i as Fi,s as Wi,e as n,k as c,w as x,t as s,M as zi,c as i,d as t,m as f,a,x as P,h as r,b as h,G as e,g as $,y as I,q as S,o as E,B as k,v as Vi,L as Yt}from"../../../../chunks/vendor-hf-doc-builder.js";import{T as Qt}from"../../../../chunks/Tip-hf-doc-builder.js";import{D as V}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as Zt}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ui}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Xt}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Gi(q){let l,y,p,m,w;return m=new Zt({props:{code:`import torch
import requests
from PIL import Image

from diffusers import StableDiffusionDepth2ImgPipeline

pipe = StableDiffusionDepth2ImgPipeline.from_pretrained(
    "stabilityai/stable-diffusion-2-depth",
    torch_dtype=torch.float16,
)
pipe.to("cuda")


url = "http://images.cocodataset.org/val2017/000000039769.jpg"
init_image = Image.open(requests.get(url, stream=True).raw)
prompt = "two tigers"
n_propmt = "bad, deformed, ugly, bad anotomy"
image = pipe(prompt=prompt, image=init_image, negative_prompt=n_propmt, strength=0.7).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionDepth2ImgPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionDepth2ImgPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;stabilityai/stable-diffusion-2-depth&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>init_image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;two tigers&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>n_propmt = <span class="hljs-string">&quot;bad, deformed, ugly, bad anotomy&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt=prompt, image=init_image, negative_prompt=n_propmt, strength=<span class="hljs-number">0.7</span>).images[<span class="hljs-number">0</span>]`}}),{c(){l=n("p"),y=s("Examples:"),p=c(),x(m.$$.fragment)},l(d){l=i(d,"P",{});var g=a(l);y=r(g,"Examples:"),g.forEach(t),p=f(d),P(m.$$.fragment,d)},m(d,g){$(d,l,g),e(l,y),$(d,p,g),I(m,d,g),w=!0},p:Yt,i(d){w||(S(m.$$.fragment,d),w=!0)},o(d){E(m.$$.fragment,d),w=!1},d(d){d&&t(l),d&&t(p),k(m,d)}}}function Ri(q){let l,y,p,m,w;return m=new Zt({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){l=n("p"),y=s("Examples:"),p=c(),x(m.$$.fragment)},l(d){l=i(d,"P",{});var g=a(l);y=r(g,"Examples:"),g.forEach(t),p=f(d),P(m.$$.fragment,d)},m(d,g){$(d,l,g),e(l,y),$(d,p,g),I(m,d,g),w=!0},p:Yt,i(d){w||(S(m.$$.fragment,d),w=!0)},o(d){E(m.$$.fragment,d),w=!1},d(d){d&&t(l),d&&t(p),k(m,d)}}}function Bi(q){let l,y;return{c(){l=n("p"),y=s("This function is experimental and might change in the future.")},l(p){l=i(p,"P",{});var m=a(l);y=r(m,"This function is experimental and might change in the future."),m.forEach(t)},m(p,m){$(p,l,m),e(l,y)},d(p){p&&t(l)}}}function Hi(q){let l,y,p,m,w,d,g,T;return{c(){l=n("p"),y=s("It is required to be logged in ("),p=n("code"),m=s("huggingface-cli login"),w=s(") when you want to use private or "),d=n("a"),g=s(`gated
models`),T=s("."),this.h()},l(u){l=i(u,"P",{});var _=a(l);y=r(_,"It is required to be logged in ("),p=i(_,"CODE",{});var A=a(p);m=r(A,"huggingface-cli login"),A.forEach(t),w=r(_,") when you want to use private or "),d=i(_,"A",{href:!0,rel:!0});var C=a(d);g=r(C,`gated
models`),C.forEach(t),T=r(_,"."),_.forEach(t),this.h()},h(){h(d,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),h(d,"rel","nofollow")},m(u,_){$(u,l,_),e(l,y),e(l,p),e(p,m),e(l,w),e(l,d),e(d,g),e(l,T)},d(u){u&&t(l)}}}function Ki(q){let l,y,p,m,w,d,g,T;return g=new Zt({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("sd-concepts-library/cat-toy")

prompt = "A <cat-toy> backpack"

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("cat-backpack.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;sd-concepts-library/cat-toy&quot;</span>)

prompt = <span class="hljs-string">&quot;A &lt;cat-toy&gt; backpack&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;cat-backpack.png&quot;</span>)`}}),{c(){l=n("p"),y=s("To load a textual inversion embedding vector in "),p=n("code"),m=s("diffusers"),w=s(" format:"),d=c(),x(g.$$.fragment)},l(u){l=i(u,"P",{});var _=a(l);y=r(_,"To load a textual inversion embedding vector in "),p=i(_,"CODE",{});var A=a(p);m=r(A,"diffusers"),A.forEach(t),w=r(_," format:"),_.forEach(t),d=f(u),P(g.$$.fragment,u)},m(u,_){$(u,l,_),e(l,y),e(l,p),e(p,m),e(l,w),$(u,d,_),I(g,u,_),T=!0},p:Yt,i(u){T||(S(g.$$.fragment,u),T=!0)},o(u){E(g.$$.fragment,u),T=!1},d(u){u&&t(l),u&&t(d),k(g,u)}}}function Ji(q){let l,y,p,m,w,d,g,T;return g=new Zt({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("./charturnerv2.pt")

prompt = "charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details."

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("character.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;./charturnerv2.pt&quot;</span>)

prompt = <span class="hljs-string">&quot;charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details.&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;character.png&quot;</span>)`}}),{c(){l=n("p"),y=s("e.g. from "),p=n("a"),m=s("civitAI"),w=s(" and then load the vector locally:"),d=c(),x(g.$$.fragment),this.h()},l(u){l=i(u,"P",{});var _=a(l);y=r(_,"e.g. from "),p=i(_,"A",{href:!0,rel:!0});var A=a(p);m=r(A,"civitAI"),A.forEach(t),w=r(_," and then load the vector locally:"),_.forEach(t),d=f(u),P(g.$$.fragment,u),this.h()},h(){h(p,"href","https://civitai.com/models/3036?modelVersionId=9857"),h(p,"rel","nofollow")},m(u,_){$(u,l,_),e(l,y),e(l,p),e(p,m),e(l,w),$(u,d,_),I(g,u,_),T=!0},p:Yt,i(u){T||(S(g.$$.fragment,u),T=!0)},o(u){E(g.$$.fragment,u),T=!1},d(u){u&&t(l),u&&t(d),k(g,u)}}}function Qi(q){let l,y;return{c(){l=n("p"),y=s("This function is experimental and might change in the future.")},l(p){l=i(p,"P",{});var m=a(l);y=r(m,"This function is experimental and might change in the future."),m.forEach(t)},m(p,m){$(p,l,m),e(l,y)},d(p){p&&t(l)}}}function Xi(q){let l,y,p,m,w,d,g,T;return{c(){l=n("p"),y=s("It is required to be logged in ("),p=n("code"),m=s("huggingface-cli login"),w=s(") when you want to use private or "),d=n("a"),g=s(`gated
models`),T=s("."),this.h()},l(u){l=i(u,"P",{});var _=a(l);y=r(_,"It is required to be logged in ("),p=i(_,"CODE",{});var A=a(p);m=r(A,"huggingface-cli login"),A.forEach(t),w=r(_,") when you want to use private or "),d=i(_,"A",{href:!0,rel:!0});var C=a(d);g=r(C,`gated
models`),C.forEach(t),T=r(_,"."),_.forEach(t),this.h()},h(){h(d,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),h(d,"rel","nofollow")},m(u,_){$(u,l,_),e(l,y),e(l,p),e(p,m),e(l,w),e(l,d),e(d,g),e(l,T)},d(u){u&&t(l)}}}function Yi(q){let l,y,p,m,w,d,g,T,u,_,A,C,Je,se,eo,Qe,to,kt,M,oo,re,no,io,le,ao,so,de,ro,lo,pe,po,co,Tt,G,Ce,fo,mo,Xe,uo,ho,At,Me,go,Lt,Ne,ce,Ye,_o,bo,fe,vo,qt,Ue,yo,jt,Oe,me,Ze,Do,wo,ue,$o,Ct,v,he,xo,et,Po,Io,ge,So,Fe,Eo,ko,To,tt,Ao,Lo,_e,be,ot,qo,jo,We,Co,Mo,ve,nt,No,Uo,ze,Oo,Fo,it,Wo,zo,at,ye,st,Vo,Go,Ve,Ro,Bo,O,De,Ho,rt,Ko,Jo,H,Qo,F,we,Xo,lt,Yo,Zo,dt,en,tn,K,$e,on,xe,nn,pt,an,sn,rn,N,Pe,ln,ct,dn,pn,ft,cn,fn,mt,mn,un,J,hn,Q,Ie,gn,ut,_n,bn,L,Se,vn,R,yn,ht,Dn,wn,gt,$n,xn,Pn,X,In,Y,Sn,_t,En,kn,Z,Tn,bt,An,Ln,ee,qn,U,Ee,jn,B,Cn,Ge,Mn,Nn,ke,vt,Un,On,Fn,te,Wn,oe,zn,ne,Te,Vn,yt,Gn,Rn,ie,Ae,Bn,Le,Hn,Dt,Kn,Jn,Mt;return d=new Ui({}),se=new Ui({}),he=new V({props:{name:"class diffusers.StableDiffusionDepth2ImgPipeline",anchor:"diffusers.StableDiffusionDepth2ImgPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"depth_estimator",val:": DPTForDepthEstimation"},{name:"feature_extractor",val:": DPTFeatureExtractor"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_2943/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_2943/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_2943/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_2943/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_2943/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_2943/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_depth2img.py#L60"}}),De=new V({props:{name:"__call__",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image] = None"},{name:"depth_map",val:": typing.Optional[torch.FloatTensor] = None"},{name:"strength",val:": float = 0.8"},{name:"num_inference_steps",val:": typing.Optional[int] = 50"},{name:"guidance_scale",val:": typing.Optional[float] = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": typing.Optional[float] = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code> or <code>PIL.Image.Image</code>) &#x2014;
<code>Image</code>, or tensor representing an image batch, that will be used as the starting point for the
process.`,name:"image"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.strength",description:`<strong>strength</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
Conceptually, indicates how much to transform the reference <code>image</code>. Must be between 0 and 1. <code>image</code>
will be used as a starting point, adding more noise to it the larger the <code>strength</code>. The number of
denoising steps depends on the amount of noise initially added. When <code>strength</code> is 1, added noise will
be maximum and the denoising process will run for the full number of iterations specified in
<code>num_inference_steps</code>. A value of 1, therefore, essentially ignores <code>image</code>.`,name:"strength"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference. This parameter will be modulated by <code>strength</code>.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code>
is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_2943/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_depth2img.py#L508",returnDescription:`
<p><a
  href="/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),H=new Xt({props:{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.__call__.example",$$slots:{default:[Gi]},$$scope:{ctx:q}}}),we=new V({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/pipeline_utils.py#L1460"}}),$e=new V({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/pipeline_utils.py#L1476"}}),Pe=new V({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/pipeline_utils.py#L1402"}}),J=new Xt({props:{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Ri]},$$scope:{ctx:q}}}),Ie=new V({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/pipeline_utils.py#L1434"}}),Se=new V({props:{name:"load_textual_inversion",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"token",val:": typing.Optional[str] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like
<code>&quot;sd-concepts-library/low-poly-hd-logos-icons&quot;</code>.</li>
<li>A path to a <em>directory</em> containing textual inversion weights, e.g.
<code>./my_text_inversion_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.weight_name",description:`<strong>weight_name</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Name of a custom weight file. This should be used in two cases:</p>
<ul>
<li>The saved textual inversion file is in <code>diffusers</code> format, but was saved under a specific weight
name, such as <code>text_inv.bin</code>.</li>
<li>The saved textual inversion file is in the &#x201C;Automatic1111&#x201D; form.</li>
</ul>`,name:"weight_name"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/loaders.py#L420"}}),X=new Qt({props:{warning:!0,$$slots:{default:[Bi]},$$scope:{ctx:q}}}),Y=new Qt({props:{$$slots:{default:[Hi]},$$scope:{ctx:q}}}),Z=new Xt({props:{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.example",$$slots:{default:[Ki]},$$scope:{ctx:q}}}),ee=new Xt({props:{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_textual_inversion.example-2",$$slots:{default:[Ji]},$$scope:{ctx:q}}}),Ee=new V({props:{name:"load_lora_weights",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights",parameters:[{name:"pretrained_model_name_or_path_or_dict",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.pretrained_model_name_or_path_or_dict",description:`<strong>pretrained_model_name_or_path_or_dict</strong> (<code>str</code> or <code>os.PathLike</code> or <code>dict</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <code>~ModelMixin.save_config</code>, e.g.,
<code>./my_model_directory/</code>.</li>
<li>A <a href="https://pytorch.org/tutorials/beginner/saving_loading_models.html#what-is-a-state-dict" rel="nofollow">torch state
dict</a>.</li>
</ul>`,name:"pretrained_model_name_or_path_or_dict"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.load_lora_weights.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/loaders.py#L678"}}),te=new Qt({props:{warning:!0,$$slots:{default:[Qi]},$$scope:{ctx:q}}}),oe=new Qt({props:{$$slots:{default:[Xi]},$$scope:{ctx:q}}}),Te=new V({props:{name:"save_lora_weights",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.save_lora_weights",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"unet_lora_layers",val:": typing.Dict[str, torch.nn.modules.module.Module] = None"},{name:"text_encoder_lora_layers",val:": typing.Dict[str, torch.nn.modules.module.Module] = None"},{name:"is_main_process",val:": bool = True"},{name:"weight_name",val:": str = None"},{name:"save_function",val:": typing.Callable = None"},{name:"safe_serialization",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.save_lora_weights.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.save_lora_weights.unet_lora_layers",description:`<strong>unet_lora_layers</strong> (<code>Dict[str, torch.nn.Module</code>]) &#x2014;
State dict of the LoRA layers corresponding to the UNet. Specifying this helps to make the
serialization process easier and cleaner.`,name:"unet_lora_layers"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.save_lora_weights.text_encoder_lora_layers",description:`<strong>text_encoder_lora_layers</strong> (<code>Dict[str, torch.nn.Module</code>]) &#x2014;
State dict of the LoRA layers corresponding to the <code>text_encoder</code>. Since the <code>text_encoder</code> comes from
<code>transformers</code>, we cannot rejig it. That is why we have to explicitly pass the text encoder LoRA state
dict.`,name:"text_encoder_lora_layers"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.save_lora_weights.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"},{anchor:"diffusers.StableDiffusionDepth2ImgPipeline.save_lora_weights.save_function",description:`<strong>save_function</strong> (<code>Callable</code>) &#x2014;
The function to use to save the state dictionary. Useful on distributed training like TPUs when one
need to replace <code>torch.save</code> by another method. Can be configured with the environment variable
<code>DIFFUSERS_SAVE_MODE</code>.`,name:"save_function"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/loaders.py#L1038"}}),Ae=new V({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionDepth2ImgPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_2943/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_depth2img.py#L135"}}),{c(){l=n("meta"),y=c(),p=n("h1"),m=n("a"),w=n("span"),x(d.$$.fragment),g=c(),T=n("span"),u=s("Depth-to-Image Generation"),_=c(),A=n("h2"),C=n("a"),Je=n("span"),x(se.$$.fragment),eo=c(),Qe=n("span"),to=s("StableDiffusionDepth2ImgPipeline"),kt=c(),M=n("p"),oo=s("The depth-guided stable diffusion model was created by the researchers and engineers from "),re=n("a"),no=s("CompVis"),io=s(", "),le=n("a"),ao=s("Stability AI"),so=s(", and "),de=n("a"),ro=s("LAION"),lo=s(", as part of Stable Diffusion 2.0. It uses "),pe=n("a"),po=s("MiDas"),co=s(" to infer depth based on an image."),Tt=c(),G=n("p"),Ce=n("a"),fo=s("StableDiffusionDepth2ImgPipeline"),mo=s(" lets you pass a text prompt and an initial image to condition the generation of new images as well as a "),Xe=n("code"),uo=s("depth_map"),ho=s(" to preserve the images\u2019 structure."),At=c(),Me=n("p"),go=s("The original codebase can be found here:"),Lt=c(),Ne=n("ul"),ce=n("li"),Ye=n("em"),_o=s("Stable Diffusion v2"),bo=s(": "),fe=n("a"),vo=s("Stability-AI/stablediffusion"),qt=c(),Ue=n("p"),yo=s("Available Checkpoints are:"),jt=c(),Oe=n("ul"),me=n("li"),Ze=n("em"),Do=s("stable-diffusion-2-depth"),wo=s(": "),ue=n("a"),$o=s("stabilityai/stable-diffusion-2-depth"),Ct=c(),v=n("div"),x(he.$$.fragment),xo=c(),et=n("p"),Po=s("Pipeline for text-guided image to image generation using Stable Diffusion."),Io=c(),ge=n("p"),So=s("This model inherits from "),Fe=n("a"),Eo=s("DiffusionPipeline"),ko=s(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),To=c(),tt=n("p"),Ao=s("In addition the pipeline inherits the following loading methods:"),Lo=c(),_e=n("ul"),be=n("li"),ot=n("em"),qo=s("Textual-Inversion"),jo=s(": "),We=n("a"),Co=s("loaders.TextualInversionLoaderMixin.load_textual_inversion()"),Mo=c(),ve=n("li"),nt=n("em"),No=s("LoRA"),Uo=s(": "),ze=n("a"),Oo=s("loaders.LoraLoaderMixin.load_lora_weights()"),Fo=c(),it=n("p"),Wo=s("as well as the following saving methods:"),zo=c(),at=n("ul"),ye=n("li"),st=n("em"),Vo=s("LoRA"),Go=s(": "),Ve=n("a"),Ro=s("loaders.LoraLoaderMixin.save_lora_weights()"),Bo=c(),O=n("div"),x(De.$$.fragment),Ho=c(),rt=n("p"),Ko=s("Function invoked when calling the pipeline for generation."),Jo=c(),x(H.$$.fragment),Qo=c(),F=n("div"),x(we.$$.fragment),Xo=c(),lt=n("p"),Yo=s("Enable sliced attention computation."),Zo=c(),dt=n("p"),en=s(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),tn=c(),K=n("div"),x($e.$$.fragment),on=c(),xe=n("p"),nn=s("Disable sliced attention computation. If "),pt=n("code"),an=s("enable_attention_slicing"),sn=s(` was previously invoked, this method will go
back to computing attention in one step.`),rn=c(),N=n("div"),x(Pe.$$.fragment),ln=c(),ct=n("p"),dn=s("Enable memory efficient attention as implemented in xformers."),pn=c(),ft=n("p"),cn=s(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),fn=c(),mt=n("p"),mn=s(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),un=c(),x(J.$$.fragment),hn=c(),Q=n("div"),x(Ie.$$.fragment),gn=c(),ut=n("p"),_n=s("Disable memory efficient attention as implemented in xformers."),bn=c(),L=n("div"),x(Se.$$.fragment),vn=c(),R=n("p"),yn=s("Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),ht=n("code"),Dn=s("diffusers"),wn=s(` and
`),gt=n("code"),$n=s("Automatic1111"),xn=s(" formats are supported (see example below)."),Pn=c(),x(X.$$.fragment),In=c(),x(Y.$$.fragment),Sn=c(),_t=n("p"),En=s("Example:"),kn=c(),x(Z.$$.fragment),Tn=c(),bt=n("p"),An=s("To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),Ln=c(),x(ee.$$.fragment),qn=c(),U=n("div"),x(Ee.$$.fragment),jn=c(),B=n("p"),Cn=s("Load pretrained attention processor layers (such as LoRA) into "),Ge=n("a"),Mn=s("UNet2DConditionModel"),Nn=s(` and
`),ke=n("a"),vt=n("code"),Un=s("CLIPTextModel"),On=s(")."),Fn=c(),x(te.$$.fragment),Wn=c(),x(oe.$$.fragment),zn=c(),ne=n("div"),x(Te.$$.fragment),Vn=c(),yt=n("p"),Gn=s("Save the LoRA parameters corresponding to the UNet and the text encoder."),Rn=c(),ie=n("div"),x(Ae.$$.fragment),Bn=c(),Le=n("p"),Hn=s(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Dt=n("code"),Kn=s("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Jn=s("forward` method called."),this.h()},l(o){const b=zi('[data-svelte="svelte-1phssyn"]',document.head);l=i(b,"META",{name:!0,content:!0}),b.forEach(t),y=f(o),p=i(o,"H1",{class:!0});var qe=a(p);m=i(qe,"A",{id:!0,class:!0,href:!0});var wt=a(m);w=i(wt,"SPAN",{});var $t=a(w);P(d.$$.fragment,$t),$t.forEach(t),wt.forEach(t),g=f(qe),T=i(qe,"SPAN",{});var xt=a(T);u=r(xt,"Depth-to-Image Generation"),xt.forEach(t),qe.forEach(t),_=f(o),A=i(o,"H2",{class:!0});var je=a(A);C=i(je,"A",{id:!0,class:!0,href:!0});var Pt=a(C);Je=i(Pt,"SPAN",{});var It=a(Je);P(se.$$.fragment,It),It.forEach(t),Pt.forEach(t),eo=f(je),Qe=i(je,"SPAN",{});var St=a(Qe);to=r(St,"StableDiffusionDepth2ImgPipeline"),St.forEach(t),je.forEach(t),kt=f(o),M=i(o,"P",{});var W=a(M);oo=r(W,"The depth-guided stable diffusion model was created by the researchers and engineers from "),re=i(W,"A",{href:!0,rel:!0});var Qn=a(re);no=r(Qn,"CompVis"),Qn.forEach(t),io=r(W,", "),le=i(W,"A",{href:!0,rel:!0});var Xn=a(le);ao=r(Xn,"Stability AI"),Xn.forEach(t),so=r(W,", and "),de=i(W,"A",{href:!0,rel:!0});var Yn=a(de);ro=r(Yn,"LAION"),Yn.forEach(t),lo=r(W,", as part of Stable Diffusion 2.0. It uses "),pe=i(W,"A",{href:!0,rel:!0});var Zn=a(pe);po=r(Zn,"MiDas"),Zn.forEach(t),co=r(W," to infer depth based on an image."),W.forEach(t),Tt=f(o),G=i(o,"P",{});var Et=a(G);Ce=i(Et,"A",{href:!0});var ei=a(Ce);fo=r(ei,"StableDiffusionDepth2ImgPipeline"),ei.forEach(t),mo=r(Et," lets you pass a text prompt and an initial image to condition the generation of new images as well as a "),Xe=i(Et,"CODE",{});var ti=a(Xe);uo=r(ti,"depth_map"),ti.forEach(t),ho=r(Et," to preserve the images\u2019 structure."),Et.forEach(t),At=f(o),Me=i(o,"P",{});var oi=a(Me);go=r(oi,"The original codebase can be found here:"),oi.forEach(t),Lt=f(o),Ne=i(o,"UL",{});var ni=a(Ne);ce=i(ni,"LI",{});var Nt=a(ce);Ye=i(Nt,"EM",{});var ii=a(Ye);_o=r(ii,"Stable Diffusion v2"),ii.forEach(t),bo=r(Nt,": "),fe=i(Nt,"A",{href:!0,rel:!0});var ai=a(fe);vo=r(ai,"Stability-AI/stablediffusion"),ai.forEach(t),Nt.forEach(t),ni.forEach(t),qt=f(o),Ue=i(o,"P",{});var si=a(Ue);yo=r(si,"Available Checkpoints are:"),si.forEach(t),jt=f(o),Oe=i(o,"UL",{});var ri=a(Oe);me=i(ri,"LI",{});var Ut=a(me);Ze=i(Ut,"EM",{});var li=a(Ze);Do=r(li,"stable-diffusion-2-depth"),li.forEach(t),wo=r(Ut,": "),ue=i(Ut,"A",{href:!0,rel:!0});var di=a(ue);$o=r(di,"stabilityai/stable-diffusion-2-depth"),di.forEach(t),Ut.forEach(t),ri.forEach(t),Ct=f(o),v=i(o,"DIV",{class:!0});var D=a(v);P(he.$$.fragment,D),xo=f(D),et=i(D,"P",{});var pi=a(et);Po=r(pi,"Pipeline for text-guided image to image generation using Stable Diffusion."),pi.forEach(t),Io=f(D),ge=i(D,"P",{});var Ot=a(ge);So=r(Ot,"This model inherits from "),Fe=i(Ot,"A",{href:!0});var ci=a(Fe);Eo=r(ci,"DiffusionPipeline"),ci.forEach(t),ko=r(Ot,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Ot.forEach(t),To=f(D),tt=i(D,"P",{});var fi=a(tt);Ao=r(fi,"In addition the pipeline inherits the following loading methods:"),fi.forEach(t),Lo=f(D),_e=i(D,"UL",{});var Ft=a(_e);be=i(Ft,"LI",{});var Wt=a(be);ot=i(Wt,"EM",{});var mi=a(ot);qo=r(mi,"Textual-Inversion"),mi.forEach(t),jo=r(Wt,": "),We=i(Wt,"A",{href:!0});var ui=a(We);Co=r(ui,"loaders.TextualInversionLoaderMixin.load_textual_inversion()"),ui.forEach(t),Wt.forEach(t),Mo=f(Ft),ve=i(Ft,"LI",{});var zt=a(ve);nt=i(zt,"EM",{});var hi=a(nt);No=r(hi,"LoRA"),hi.forEach(t),Uo=r(zt,": "),ze=i(zt,"A",{href:!0});var gi=a(ze);Oo=r(gi,"loaders.LoraLoaderMixin.load_lora_weights()"),gi.forEach(t),zt.forEach(t),Ft.forEach(t),Fo=f(D),it=i(D,"P",{});var _i=a(it);Wo=r(_i,"as well as the following saving methods:"),_i.forEach(t),zo=f(D),at=i(D,"UL",{});var bi=a(at);ye=i(bi,"LI",{});var Vt=a(ye);st=i(Vt,"EM",{});var vi=a(st);Vo=r(vi,"LoRA"),vi.forEach(t),Go=r(Vt,": "),Ve=i(Vt,"A",{href:!0});var yi=a(Ve);Ro=r(yi,"loaders.LoraLoaderMixin.save_lora_weights()"),yi.forEach(t),Vt.forEach(t),bi.forEach(t),Bo=f(D),O=i(D,"DIV",{class:!0});var Re=a(O);P(De.$$.fragment,Re),Ho=f(Re),rt=i(Re,"P",{});var Di=a(rt);Ko=r(Di,"Function invoked when calling the pipeline for generation."),Di.forEach(t),Jo=f(Re),P(H.$$.fragment,Re),Re.forEach(t),Qo=f(D),F=i(D,"DIV",{class:!0});var Be=a(F);P(we.$$.fragment,Be),Xo=f(Be),lt=i(Be,"P",{});var wi=a(lt);Yo=r(wi,"Enable sliced attention computation."),wi.forEach(t),Zo=f(Be),dt=i(Be,"P",{});var $i=a(dt);en=r($i,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),$i.forEach(t),Be.forEach(t),tn=f(D),K=i(D,"DIV",{class:!0});var Gt=a(K);P($e.$$.fragment,Gt),on=f(Gt),xe=i(Gt,"P",{});var Rt=a(xe);nn=r(Rt,"Disable sliced attention computation. If "),pt=i(Rt,"CODE",{});var xi=a(pt);an=r(xi,"enable_attention_slicing"),xi.forEach(t),sn=r(Rt,` was previously invoked, this method will go
back to computing attention in one step.`),Rt.forEach(t),Gt.forEach(t),rn=f(D),N=i(D,"DIV",{class:!0});var z=a(N);P(Pe.$$.fragment,z),ln=f(z),ct=i(z,"P",{});var Pi=a(ct);dn=r(Pi,"Enable memory efficient attention as implemented in xformers."),Pi.forEach(t),pn=f(z),ft=i(z,"P",{});var Ii=a(ft);cn=r(Ii,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Ii.forEach(t),fn=f(z),mt=i(z,"P",{});var Si=a(mt);mn=r(Si,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Si.forEach(t),un=f(z),P(J.$$.fragment,z),z.forEach(t),hn=f(D),Q=i(D,"DIV",{class:!0});var Bt=a(Q);P(Ie.$$.fragment,Bt),gn=f(Bt),ut=i(Bt,"P",{});var Ei=a(ut);_n=r(Ei,"Disable memory efficient attention as implemented in xformers."),Ei.forEach(t),Bt.forEach(t),bn=f(D),L=i(D,"DIV",{class:!0});var j=a(L);P(Se.$$.fragment,j),vn=f(j),R=i(j,"P",{});var He=a(R);yn=r(He,"Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),ht=i(He,"CODE",{});var ki=a(ht);Dn=r(ki,"diffusers"),ki.forEach(t),wn=r(He,` and
`),gt=i(He,"CODE",{});var Ti=a(gt);$n=r(Ti,"Automatic1111"),Ti.forEach(t),xn=r(He," formats are supported (see example below)."),He.forEach(t),Pn=f(j),P(X.$$.fragment,j),In=f(j),P(Y.$$.fragment,j),Sn=f(j),_t=i(j,"P",{});var Ai=a(_t);En=r(Ai,"Example:"),Ai.forEach(t),kn=f(j),P(Z.$$.fragment,j),Tn=f(j),bt=i(j,"P",{});var Li=a(bt);An=r(Li,"To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),Li.forEach(t),Ln=f(j),P(ee.$$.fragment,j),j.forEach(t),qn=f(D),U=i(D,"DIV",{class:!0});var ae=a(U);P(Ee.$$.fragment,ae),jn=f(ae),B=i(ae,"P",{});var Ke=a(B);Cn=r(Ke,"Load pretrained attention processor layers (such as LoRA) into "),Ge=i(Ke,"A",{href:!0});var qi=a(Ge);Mn=r(qi,"UNet2DConditionModel"),qi.forEach(t),Nn=r(Ke,` and
`),ke=i(Ke,"A",{href:!0,rel:!0});var ji=a(ke);vt=i(ji,"CODE",{});var Ci=a(vt);Un=r(Ci,"CLIPTextModel"),Ci.forEach(t),ji.forEach(t),On=r(Ke,")."),Ke.forEach(t),Fn=f(ae),P(te.$$.fragment,ae),Wn=f(ae),P(oe.$$.fragment,ae),ae.forEach(t),zn=f(D),ne=i(D,"DIV",{class:!0});var Ht=a(ne);P(Te.$$.fragment,Ht),Vn=f(Ht),yt=i(Ht,"P",{});var Mi=a(yt);Gn=r(Mi,"Save the LoRA parameters corresponding to the UNet and the text encoder."),Mi.forEach(t),Ht.forEach(t),Rn=f(D),ie=i(D,"DIV",{class:!0});var Kt=a(ie);P(Ae.$$.fragment,Kt),Bn=f(Kt),Le=i(Kt,"P",{});var Jt=a(Le);Hn=r(Jt,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Dt=i(Jt,"CODE",{});var Ni=a(Dt);Kn=r(Ni,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),Ni.forEach(t),Jn=r(Jt,"forward` method called."),Jt.forEach(t),Kt.forEach(t),D.forEach(t),this.h()},h(){h(l,"name","hf:doc:metadata"),h(l,"content",JSON.stringify(Zi)),h(m,"id","depthtoimage-generation"),h(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(m,"href","#depthtoimage-generation"),h(p,"class","relative group"),h(C,"id","diffusers.StableDiffusionDepth2ImgPipeline"),h(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(C,"href","#diffusers.StableDiffusionDepth2ImgPipeline"),h(A,"class","relative group"),h(re,"href","https://github.com/CompVis"),h(re,"rel","nofollow"),h(le,"href","https://stability.ai/"),h(le,"rel","nofollow"),h(de,"href","https://laion.ai/"),h(de,"rel","nofollow"),h(pe,"href","https://github.com/isl-org/MiDaS"),h(pe,"rel","nofollow"),h(Ce,"href","/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/depth2img#diffusers.StableDiffusionDepth2ImgPipeline"),h(fe,"href","https://github.com/Stability-AI/stablediffusion#depth-conditional-stable-diffusion"),h(fe,"rel","nofollow"),h(ue,"href","https://huggingface.co/stabilityai/stable-diffusion-2-depth"),h(ue,"rel","nofollow"),h(Fe,"href","/docs/diffusers/pr_2943/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),h(We,"href","/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.load_textual_inversion"),h(ze,"href","/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.load_lora_weights"),h(Ve,"href","/docs/diffusers/pr_2943/en/api/pipelines/stable_diffusion/inpaint#diffusers.StableDiffusionInpaintPipeline.save_lora_weights"),h(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ge,"href","/docs/diffusers/pr_2943/en/api/models#diffusers.UNet2DConditionModel"),h(ke,"href","https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel"),h(ke,"rel","nofollow"),h(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,b){e(document.head,l),$(o,y,b),$(o,p,b),e(p,m),e(m,w),I(d,w,null),e(p,g),e(p,T),e(T,u),$(o,_,b),$(o,A,b),e(A,C),e(C,Je),I(se,Je,null),e(A,eo),e(A,Qe),e(Qe,to),$(o,kt,b),$(o,M,b),e(M,oo),e(M,re),e(re,no),e(M,io),e(M,le),e(le,ao),e(M,so),e(M,de),e(de,ro),e(M,lo),e(M,pe),e(pe,po),e(M,co),$(o,Tt,b),$(o,G,b),e(G,Ce),e(Ce,fo),e(G,mo),e(G,Xe),e(Xe,uo),e(G,ho),$(o,At,b),$(o,Me,b),e(Me,go),$(o,Lt,b),$(o,Ne,b),e(Ne,ce),e(ce,Ye),e(Ye,_o),e(ce,bo),e(ce,fe),e(fe,vo),$(o,qt,b),$(o,Ue,b),e(Ue,yo),$(o,jt,b),$(o,Oe,b),e(Oe,me),e(me,Ze),e(Ze,Do),e(me,wo),e(me,ue),e(ue,$o),$(o,Ct,b),$(o,v,b),I(he,v,null),e(v,xo),e(v,et),e(et,Po),e(v,Io),e(v,ge),e(ge,So),e(ge,Fe),e(Fe,Eo),e(ge,ko),e(v,To),e(v,tt),e(tt,Ao),e(v,Lo),e(v,_e),e(_e,be),e(be,ot),e(ot,qo),e(be,jo),e(be,We),e(We,Co),e(_e,Mo),e(_e,ve),e(ve,nt),e(nt,No),e(ve,Uo),e(ve,ze),e(ze,Oo),e(v,Fo),e(v,it),e(it,Wo),e(v,zo),e(v,at),e(at,ye),e(ye,st),e(st,Vo),e(ye,Go),e(ye,Ve),e(Ve,Ro),e(v,Bo),e(v,O),I(De,O,null),e(O,Ho),e(O,rt),e(rt,Ko),e(O,Jo),I(H,O,null),e(v,Qo),e(v,F),I(we,F,null),e(F,Xo),e(F,lt),e(lt,Yo),e(F,Zo),e(F,dt),e(dt,en),e(v,tn),e(v,K),I($e,K,null),e(K,on),e(K,xe),e(xe,nn),e(xe,pt),e(pt,an),e(xe,sn),e(v,rn),e(v,N),I(Pe,N,null),e(N,ln),e(N,ct),e(ct,dn),e(N,pn),e(N,ft),e(ft,cn),e(N,fn),e(N,mt),e(mt,mn),e(N,un),I(J,N,null),e(v,hn),e(v,Q),I(Ie,Q,null),e(Q,gn),e(Q,ut),e(ut,_n),e(v,bn),e(v,L),I(Se,L,null),e(L,vn),e(L,R),e(R,yn),e(R,ht),e(ht,Dn),e(R,wn),e(R,gt),e(gt,$n),e(R,xn),e(L,Pn),I(X,L,null),e(L,In),I(Y,L,null),e(L,Sn),e(L,_t),e(_t,En),e(L,kn),I(Z,L,null),e(L,Tn),e(L,bt),e(bt,An),e(L,Ln),I(ee,L,null),e(v,qn),e(v,U),I(Ee,U,null),e(U,jn),e(U,B),e(B,Cn),e(B,Ge),e(Ge,Mn),e(B,Nn),e(B,ke),e(ke,vt),e(vt,Un),e(B,On),e(U,Fn),I(te,U,null),e(U,Wn),I(oe,U,null),e(v,zn),e(v,ne),I(Te,ne,null),e(ne,Vn),e(ne,yt),e(yt,Gn),e(v,Rn),e(v,ie),I(Ae,ie,null),e(ie,Bn),e(ie,Le),e(Le,Hn),e(Le,Dt),e(Dt,Kn),e(Le,Jn),Mt=!0},p(o,[b]){const qe={};b&2&&(qe.$$scope={dirty:b,ctx:o}),H.$set(qe);const wt={};b&2&&(wt.$$scope={dirty:b,ctx:o}),J.$set(wt);const $t={};b&2&&($t.$$scope={dirty:b,ctx:o}),X.$set($t);const xt={};b&2&&(xt.$$scope={dirty:b,ctx:o}),Y.$set(xt);const je={};b&2&&(je.$$scope={dirty:b,ctx:o}),Z.$set(je);const Pt={};b&2&&(Pt.$$scope={dirty:b,ctx:o}),ee.$set(Pt);const It={};b&2&&(It.$$scope={dirty:b,ctx:o}),te.$set(It);const St={};b&2&&(St.$$scope={dirty:b,ctx:o}),oe.$set(St)},i(o){Mt||(S(d.$$.fragment,o),S(se.$$.fragment,o),S(he.$$.fragment,o),S(De.$$.fragment,o),S(H.$$.fragment,o),S(we.$$.fragment,o),S($e.$$.fragment,o),S(Pe.$$.fragment,o),S(J.$$.fragment,o),S(Ie.$$.fragment,o),S(Se.$$.fragment,o),S(X.$$.fragment,o),S(Y.$$.fragment,o),S(Z.$$.fragment,o),S(ee.$$.fragment,o),S(Ee.$$.fragment,o),S(te.$$.fragment,o),S(oe.$$.fragment,o),S(Te.$$.fragment,o),S(Ae.$$.fragment,o),Mt=!0)},o(o){E(d.$$.fragment,o),E(se.$$.fragment,o),E(he.$$.fragment,o),E(De.$$.fragment,o),E(H.$$.fragment,o),E(we.$$.fragment,o),E($e.$$.fragment,o),E(Pe.$$.fragment,o),E(J.$$.fragment,o),E(Ie.$$.fragment,o),E(Se.$$.fragment,o),E(X.$$.fragment,o),E(Y.$$.fragment,o),E(Z.$$.fragment,o),E(ee.$$.fragment,o),E(Ee.$$.fragment,o),E(te.$$.fragment,o),E(oe.$$.fragment,o),E(Te.$$.fragment,o),E(Ae.$$.fragment,o),Mt=!1},d(o){t(l),o&&t(y),o&&t(p),k(d),o&&t(_),o&&t(A),k(se),o&&t(kt),o&&t(M),o&&t(Tt),o&&t(G),o&&t(At),o&&t(Me),o&&t(Lt),o&&t(Ne),o&&t(qt),o&&t(Ue),o&&t(jt),o&&t(Oe),o&&t(Ct),o&&t(v),k(he),k(De),k(H),k(we),k($e),k(Pe),k(J),k(Ie),k(Se),k(X),k(Y),k(Z),k(ee),k(Ee),k(te),k(oe),k(Te),k(Ae)}}}const Zi={local:"depthtoimage-generation",sections:[{local:"diffusers.StableDiffusionDepth2ImgPipeline",title:"StableDiffusionDepth2ImgPipeline"}],title:"Depth-to-Image Generation"};function ea(q){return Vi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ra extends Oi{constructor(l){super();Fi(this,l,ea,Yi,Wi,{})}}export{ra as default,Zi as metadata};
